<?php
if ( ! class_exists( 'Film_Production_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Film_Production_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Film_Production_Plugin_Activation_WPElemento_Importer {

        private static $film_production_instance;
        public $film_production_action_count;
        public $film_production_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$film_production_instance) ) {
            self::$film_production_instance = new self();
          }
          return self::$film_production_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'film_production_recommended_plugins', array($this, 'film_production_recommended_elemento_importer_plugins_array') );

            $film_production_actions                   = $this->film_production_get_recommended_actions();
            $this->film_production_action_count        = $film_production_actions['count'];
            $this->film_production_recommended_actions = $film_production_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function film_production_recommended_elemento_importer_plugins_array($film_production_plugins){
            $film_production_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'film-production'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'film-production'),               
            );
            return $film_production_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'film-production-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('film-production-plugin-activation-script', 'film_production_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'film-production'),
                    'activating' => esc_html__('Activating', 'film-production'),
                    'error' => esc_html__('Error', 'film-production'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'film-production-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function film_production_get_recommended_actions() {

            $film_production_act_count  = 0;
            $film_production_actions_todo = get_option( 'recommending_actions', array());

            $film_production_plugins = $this->film_production_get_recommended_plugins();

            if ($film_production_plugins) {
                foreach ($film_production_plugins as $film_production_key => $film_production_plugin) {
                    $film_production_action = array();
                    if (!isset($film_production_plugin['slug'])) {
                        continue;
                    }

                    $film_production_action['id']   = 'install_' . $film_production_plugin['slug'];
                    $film_production_action['desc'] = '';
                    if (isset($film_production_plugin['desc'])) {
                        $film_production_action['desc'] = $film_production_plugin['desc'];
                    }

                    $film_production_action['name'] = '';
                    if (isset($film_production_plugin['name'])) {
                        $film_production_action['title'] = $film_production_plugin['name'];
                    }

                    $film_production_link_and_is_done  = $this->film_production_get_plugin_buttion($film_production_plugin['slug'], $film_production_plugin['name'], $film_production_plugin['function']);
                    $film_production_action['link']    = $film_production_link_and_is_done['button'];
                    $film_production_action['is_done'] = $film_production_link_and_is_done['done'];
                    if (!$film_production_action['is_done'] && (!isset($film_production_actions_todo[$film_production_action['id']]) || !$film_production_actions_todo[$film_production_action['id']])) {
                        $film_production_act_count++;
                    }
                    $film_production_recommended_actions[] = $film_production_action;
                    $film_production_actions_todo[]        = array('id' => $film_production_action['id'], 'watch' => true);
                }
                return array('count' => $film_production_act_count, 'actions' => $film_production_recommended_actions);
            }

        }

        public function film_production_get_recommended_plugins() {

            $film_production_plugins = apply_filters('film_production_recommended_plugins', array());
            return $film_production_plugins;
        }

        public function film_production_get_plugin_buttion($slug, $name, $function) {
                $film_production_is_done      = false;
                $film_production_button_html  = '';
                $film_production_is_installed = $this->is_plugin_installed($slug);
                $film_production_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $film_production_is_activeted = (class_exists($function)) ? true : false;
                if (!$film_production_is_installed) {
                    $film_production_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $film_production_plugin_install_url = wp_nonce_url($film_production_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $film_production_button_html        = sprintf('<a class="film-production-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($film_production_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'film-production'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'film-production')
                    );
                } elseif ($film_production_is_installed && !$film_production_is_activeted) {

                    $film_production_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($film_production_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $film_production_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $film_production_button_html = sprintf('<a class="film-production-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($film_production_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'film-production'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'film-production')
                    );
                } elseif ($film_production_is_activeted) {
                    $film_production_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'film-production'));
                    $film_production_is_done     = true;
                }

                return array('done' => $film_production_is_done, 'button' => $film_production_button_html);
            }
        public function is_plugin_installed($slug) {
            $film_production_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $film_production_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($film_production_installed_plugins[$film_production_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $film_production_keys = array_keys($this->get_installed_plugins());
            foreach ($film_production_keys as $film_production_key) {
                if (preg_match('|^' . $slug . '/|', $film_production_key)) {
                    return $film_production_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Film_Production_Plugin_Activation_WPElemento_Importer::get_instance();